class RoomOccupancyTooHighException
      extends Exception {}                      // (1) Checked Exception
class BankrupcyException
      extends RuntimeException {}               // (2) Unchecked Exception

class Hotel {
    // Instance Members
    private boolean bankrupt         = true;
    private int     noOfRooms        = 215;
    private int     occupancyPerRoom = 5;
    private int     maxNoOfGuests;

    {                                           // (3) Instance block
        try {
             if (occupancyPerRoom > 4)          // (4) Handles checked exception
                 throw new RoomOccupancyTooHighException();
        } catch (RoomOccupancyTooHighException exception) {
             System.out.println("ROOM OCCUPANCY TOO HIGH: " + occupancyPerRoom);
             occupancyPerRoom = 4;
        }
        maxNoOfGuests = noOfRooms * occupancyPerRoom;
    }

    {                                           // (5) Instance initializer block
        if (bankrupt)
            throw new BankrupcyException();     // (6) Throws unchecked exception
    }    // ...
}

public class ExceptionsInInstBlocks {
    public static void main(String[] args) {
        new Hotel();
    }
}