import java.util.*;

public class Concordance {

    /** Map for the concordance. */
    public Map index = new HashMap();

    /** Add each character and its index to the concordance */
    public Concordance(String input) {
        for (int i=0; i<input.length(); ++i) {
            addEntry(input.charAt(i), i);
        }
    }

    /** Update the list of indices for a given character */
    void addEntry(char c, int pos) {
        Character key = new Character(c);
        List hits = (List) index.get(key);
        if (hits == null) {
            hits = new ArrayList();
            index.put(key, hits);
        }
        hits.add(new Integer(pos));
    }

    public static void main(String[] args) {
        StringBuffer input = new StringBuffer();
        for (int i=0; i<args.length; ++i)
            input.append(args[i]);
        Concordance conc = new Concordance(input.toString());
        System.out.println(conc.index);
    }
};